package it.unitn.disi.MR;

import java.util.ArrayList;
import java.util.List;
import javafx.animation.TranslateTransition;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.util.Duration;

public class Car extends Circle {
    static List<Car> carList=new ArrayList<Car>();
    private Strada currentPos=null;
    private Strada destination=null;
    Car(Strada s) {
        super(0,0,10);
        this.setStroke(Color.RED);
        currentPos=s;
        destination=s;
        carList.add(this);
    }
    public Strada getCurrentPosition() {
        return currentPos;
    }
    public void setCurrentPosition(Strada pos) {
        currentPos=pos;
    }
    public Strada getDestination() {
        return destination;
    }
    /**
    /**
     * verifica che lo spostamento sia permesso
     * @param dx spostamento lungo le colonne
     * @param dy spostamento lungo le righe
     * @return la destinazione: null se mossa non possibile
     */
    Strada checkCarMove(int dx, int dy) {
        Strada origin = getCurrentPosition();
        int newCol = origin.colPos + dx;
        int newRiga = origin.rigaPos + dy;
        System.out.println("============");
        System.out.println("current pos " + origin.rigaPos + " " + origin.colPos);
        System.out.println("new pos " + newRiga + " " + newCol);
        if ((newCol < 0)
                || (newCol >= Griglia.NCOL)
                || (newRiga < 0)
                || (newRiga >= Griglia.NROW)) {
            System.out.println(origin+" destination out of boundary "+newCol+" "+newRiga);
            return null;
        }
        Terreno target = (Terreno) origin.mainWindow.griglia.getElementAt(newRiga, newCol);
        if (!(target instanceof Strada)) {
            System.out.println("target " + target + " not a Strada");
            return null;
        }
        System.out.println("Mossa ok - target " + target + " " + target.rigaPos + " " + target.colPos);
        return((Strada)target);
    }
    /**
     * prepara una transizione di traslazione 
     * @param destination destinazione della transizione
     * @return la transizione
     */
    TranslateTransition prepareCarTranslation(Strada destination){
        Strada origin = getCurrentPosition();
        destination.toBack();
        toFront();
        double draw_dx = (destination.colPos - origin.colPos) * origin.getWidth();
        double draw_dy = (destination.rigaPos - origin.rigaPos) * origin.getHeight();
        TranslateTransition tt = new TranslateTransition(Duration.millis(1000), this);
        tt.setToX(draw_dx);
        tt.setToY(draw_dy);
        final Car thisCar=this;
        tt.setOnFinished(new EventHandler<ActionEvent>() {
                    public void handle(ActionEvent event) {
                        thisCar.destination=destination;
                    }
                });
        return tt;
    }
}
