package it.unitn.disi.MR;

import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;

class ControlWindow extends Stage {

    MainWindow mainWindow = null;
    Button startButton = new StartButton();
    Button stopButton = new StopButton();
        
    ControlWindow(MainWindow mainWindow) {
        this.mainWindow = mainWindow;
        //==================================
        // Pannello con i 4 bottoni di direzione
        BorderPane fourDirectionsBP = new BorderPane();
        Button giuButton = new MotionButton("giu", 0, 1);
        Button suButton = new MotionButton("su", 0, -1);
        fourDirectionsBP.setTop(suButton);
        fourDirectionsBP.setBottom(giuButton);
        BorderPane.setAlignment(giuButton, Pos.CENTER);
        BorderPane.setAlignment(suButton, Pos.CENTER);
        fourDirectionsBP.setLeft(new MotionButton("sinistra", -1, 0));
        fourDirectionsBP.setRight(new MotionButton("destra", 1, 0));
        //====================================
        // Pannello con i restanti bottoni
        BorderPane extraButtonsBP = new BorderPane();
        Button randomButton = new MotionButton("random", 0, 0);
        BorderPane.setAlignment(randomButton, Pos.CENTER);
        stopButton.setDisable(true);
        extraButtonsBP.setBottom(randomButton);
        //extraButtonsBP.setTop(new Label(""));
        extraButtonsBP.setLeft(startButton);
        extraButtonsBP.setRight(stopButton);
        //================================
        // pannello globale
        BorderPane outerBP = new BorderPane();
        outerBP.setLeft(fourDirectionsBP);
        outerBP.setRight(extraButtonsBP);

        Scene scene = new Scene(outerBP);
        this.setScene(scene);
    }

    class MotionButton extends Button {
        MotionButton(String label, int dx, int dy) {
            super(label);
            addEventHandler(ActionEvent.ACTION, new EventHandler<ActionEvent>() {
                public void handle(ActionEvent event) {
                    mainWindow.moveCars(dx, dy);
                }
            });
        }
    }

    class StartButton extends Button {
        StartButton() {
            super("Start");
            addEventHandler(ActionEvent.ACTION, new EventHandler<ActionEvent>() {
                public void handle(ActionEvent event) {
                    stopButton.setDisable(false);
                    setDisable(true);
                    mainWindow.loopIsActive=true;
                    mainWindow.moveCars(0, 0);
                }
            });
        }
    }
    class StopButton extends Button {
        StopButton() {
            super("Stop");
            addEventHandler(ActionEvent.ACTION, new EventHandler<ActionEvent>() {
                public void handle(ActionEvent event) {
                    startButton.setDisable(false);
                    setDisable(true);
                    mainWindow.loopIsActive=false;
                }
            });
        }
    }
}
