package it.unitn.disi.MR;

import javafx.scene.Node;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.RowConstraints;

class Griglia extends GridPane {

    static final int NCOL = 8;
    static final int NROW = 8;

    Griglia(MainWindow mainWindow) {
        // vincola le righe e colonne ad occupare tutto lo spazio disponibile
        ColumnConstraints cc1 = new ColumnConstraints();
        cc1.setPercentWidth(100. / NCOL);
        RowConstraints rc1 = new RowConstraints();
        rc1.setPercentHeight(100. / NROW);
        getColumnConstraints().addAll(cc1, cc1, cc1, cc1, cc1, cc1, cc1, cc1);
        getRowConstraints().addAll(rc1, rc1, rc1, rc1, rc1, rc1, rc1, rc1);
        Terreno x = null;
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                if (i == 0 || i == 7) {
                    x = new Strada(i, j, mainWindow);
                } else if (j == 0 || j == 7) {
                    x = new Strada(i, j, mainWindow);
                } else {
                    x = new Prato(i, j, mainWindow);
                }
                this.add(x, i, j);
            }
        }
    }

    /**
     * implementazione generale del metodo per trovare quale elementi si trovi
     * in posizione i,j in un GridPane. Funziona in qualunque caso.
     *
     * @param i riga
     * @param j colonna
     * @return l'elemento trovato
     */
    Node standardGetElementAt(int i, int j) {
        for (Node x : getChildren()) {
            if ((GridPane.getRowIndex(x) == i) && (GridPane.getColumnIndex(x) == j)) {
                return x;
            }
        }
        return null;
    }

    /**
     * implementazione specifica del metodo per trovare quale elementi si trovi
     * in posizione i,j nella griglia. Sfrutta le proprietà di Terreno.
     *
     * @param i riga
     * @param j colonna
     * @return l'elemento trovato
     */
    Terreno getElementAt(int i, int j) {
        for (Node x : this.getChildren()) {
            Terreno t = (Terreno) x;
            if ((t.rigaPos == i) && (t.colPos == j)) {
                return t;
            }
        }
        return null;
    }
}
