package it.unitn.disi.MR;

import javafx.application.Platform;
import javafx.event.EventHandler;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.WindowEvent;
/**
 * Finestra modale alla cui chiusura l'app termina
 */
class ModalDialog {
    Stage stage = new Stage();

/**
 * Shows a modal pop-up window, i.e. a window that blocks actions on the
 * window which generate it until the pop-up is closed.
 * When the pop-up is closed, the app will quit.
 *
 * @param message message to be shown in the popup
 * @param ownerWindow window owner this dialog
 */
    public void showPopup(String message, Stage ownerWindow) {
        Label label = new Label(message);
        label.setAlignment(Pos.CENTER);
        label.setFont(Font.font("Arial", FontWeight.BOLD, 20));
        Scene sc = new Scene(label, 500, 200);
        stage.setScene(sc);
        stage.setX(100);
        stage.setY(100);
        stage.initModality(Modality.WINDOW_MODAL);
        stage.initOwner(ownerWindow);
        stage.setOnCloseRequest(new EventHandler<WindowEvent>() {
        public void handle(WindowEvent event) {
            Platform.exit();
            }
        });
        stage.show();
    }
}
