package it.unitn.disi.MR;

public class Strada extends Terreno {
    static boolean addCarMode = false;
    private boolean hasCar = false;
    private Car car = null;
    Strada(int i, int j, MainWindow mainWindow) {
        super(i, j, mainWindow);
        System.out.println("aggiungo Strada " + i + " " + j);
        //setBackground(new Background(new BackgroundFill(Color.GRAY, CornerRadii.EMPTY, Insets.EMPTY)));
        setStyle("-fx-border-color: #000000; -fx-border-width: 1px; -fx-background-color: gray;");
    }
    @Override
    void manageClick() {
        System.out.println("addCarMode:"+addCarMode+" hasCar:"+hasCar);
        // are we in addCarMode, and no car is present?
        if (addCarMode) {
            if (!hasCar) {
                addNewCar();
                addCarMode = false;
            }
            return;
        }
        // qualunque cosa accada, esci da addCarmode //
        addCarMode = false;
        if (!hasCar) {
            mainWindow.remove(this);
            mainWindow.add(new Prato(colPos, rigaPos, mainWindow), colPos, rigaPos);
        }
    }
    /**
     * Creazione di una nuova macchina e attribuzione della stessa ad una Strada
     */
    private void addNewCar() {
        car = new Car(this);
        this.getChildren().add(car);
        mainWindow.decreaseAvailableCars();
        hasCar=true;
    }
    /**
     * Aggiungi una macchina esistente (proveniente da un'altra cella) a questa strada
     * @param car l'auto da aggiungere
     */
    void addCar(Car car) {
        System.out.println("adding car to "+this+" "+colPos+" "+rigaPos);
        this.getChildren().add(car);
        hasCar=true;
        this.car=car;
        //reset la traslazione della macchina, che potrebbe essere stata aggiunta
        // dall'animazione
        car.setTranslateX(0);
        car.setTranslateY(0);
        // garantisciti che l'auto sia in primo piano
        car.toFront();
    }
    /**
     * Rimuovi la macchina associata con questa Strada (perchè è andata altrove)
     */
    void removeCar() {
        System.out.println("removing car from "+this+" "+colPos+" "+rigaPos);
        this.getChildren().remove(car);
        hasCar=false;
        this.car=null;
    }
}
